lomiri::shell::application::ApplicationManagerInterface Class Referenceabstract

The Application manager. More...

`#include <lomiri/shell/application/ApplicationManagerInterface.h>`

Inheritance diagram for lomiri::shell::application::ApplicationManagerInterface:
[legend]
Collaboration diagram for lomiri::shell::application::ApplicationManagerInterface:
[legend]

## Public Types

enum | Roles { RoleAppId = Qt::UserRole , RoleName , RoleComment , RoleIcon , RoleState , RoleFocused , RoleIsTouchApp , RoleExemptFromLifecycle , RoleApplication }
| The Roles supported by the model. More...

## Signals

void | focusRequested (const QString &appId)
| Will be emitted right before the focused application changes. More...
void | focusedApplicationIdChanged ()
| Will be emitted whenever the focused application changes.

## Public Member Functions

virtual Q_INVOKABLE lomiri::shell::application::ApplicationInfoInterface * | get (int index) const =0
| Get an ApplicationInfo item (using stack index). More...
virtual Q_INVOKABLE lomiri::shell::application::ApplicationInfoInterface * | findApplication (const QString &appId) const =0
| Get an ApplicationInfo item (using the appId). More...
virtual ApplicationInfoInterface * | findApplicationWithSurface (MirSurfaceInterface *surface) const =0
virtual Q_INVOKABLE bool | requestFocusApplication (const QString &appId)=0
| Request to focus a given application. More...
virtual Q_INVOKABLE lomiri::shell::application::ApplicationInfoInterface * | startApplication (const QString &appId, const QStringList &arguments)=0
| Start an application. More...
virtual Q_INVOKABLE bool | stopApplication (const QString &appId)=0
| Stops an application. More...

## Properties

int | count
| The count of the applications known to the manager. More...
QString | focusedApplicationId
| The currently focused application. More...

## Detailed Description

The Application manager.

This is the main class to interact with Applications

## Member Enumeration Documentation

## Roles

enum lomiri::shell::application::ApplicationManagerInterface::Roles

The Roles supported by the model.

See ApplicationInfoInterface properties for details.

## Member Function Documentation

## findApplication()

virtual Q_INVOKABLE lomiri::shell::application::ApplicationInfoInterface* lomiri::shell::application::ApplicationManagerInterface::findApplication | ( | const QString & | appId | ) | const

pure virtual

Get an ApplicationInfo item (using the appId).

Note: QML requires the full namespace in the return value.

Parameters

  appId | the appId of the item to get

Returns
  The item, or null if not found.

## focusRequested

void lomiri::shell::application::ApplicationManagerInterface::focusRequested | ( | const QString & | appId | ) |

signal

Will be emitted right before the focused application changes.

This can be used to prepare for an upcoming focus change. For example starting an animation.

## get()

virtual Q_INVOKABLE lomiri::shell::application::ApplicationInfoInterface* lomiri::shell::application::ApplicationManagerInterface::get | ( | int | index | ) | const

pure virtual

Get an ApplicationInfo item (using stack index).

Note: QML requires the full namespace in the return value.

Parameters

  index | the index of the item to get

Returns
  The item, or null if not found.

## requestFocusApplication()

virtual Q_INVOKABLE bool lomiri::shell::application::ApplicationManagerInterface::requestFocusApplication | ( | const QString & | appId | ) |

pure virtual

Request to focus a given application.

This will request the shell to focus the given application.

Parameters

  appId | The appId of the app to be focused.

Returns
  True if the request will processed, false if it was discarded (i.e. the given appid could not be found)

## startApplication()

virtual Q_INVOKABLE lomiri::shell::application::ApplicationInfoInterface* lomiri::shell::application::ApplicationManagerInterface::startApplication | ( | const QString & | appId,
|  | const QStringList & | arguments
| ) |  |

pure virtual

Start an application.

Parameters

  appId | The appId for the application to be spawned.
  arguments | Any arguments to be passed to the process.

Returns
  The created application item if start successful, else null.

## stopApplication()

virtual Q_INVOKABLE bool lomiri::shell::application::ApplicationManagerInterface::stopApplication | ( | const QString & | appId | ) |

pure virtual

Stops an application.

Parameters

  appId | The application to be stopped.

Returns
  True if application stop successful, else false (i.e. false if application was not running).

## Property Documentation

## count

int lomiri::shell::application::ApplicationManagerInterface::count

read

The count of the applications known to the manager.

This is the same as rowCount, added in order to keep compatibility with QML ListModels.

## focusedApplicationId

QString lomiri::shell::application::ApplicationManagerInterface::focusedApplicationId

read

The currently focused application.

Use focusApplication() and unfocusCurrentApplication() to modify this.

The documentation for this class was generated from the following file:

- include/lomiri/shell/application/ApplicationManagerInterface.h